var t = {
	in_array: function(needle, haystack) 
	{
	    for(var i in haystack) 
	    {
	        if(haystack[i] == needle) return true;
	    }
	    return false;
	},
	goBack: function(){
		page.activate(c.backpage);
	},
	id: function(str)
	{
		return str.toLowerCase().replace(/[^a-z0-9]/,'');
	},
	number: function(num){
		return this.number_format(num,1,',','.');
	},
	/*
	 * get nice formatted date and time from php timestamp (seconds)
	 */
	dateTime: function(timestamp)
	{
		months = ['Jan','Feb','Mär','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez'];
		date = new Date(parseInt(timestamp)*1000);
		//alert('date:'+date);
		return date.getDate() + '. ' + months[date.getMonth() - 1] + ' ' + date.getHours() + ':' + date.getMinutes() + ' Uhr';
	},
	serialize: function(obj)
	{
		return JSON.stringify(obj);
	},
	unserialize: function(str)
	{
		return JSON.parse(str);
	},
	scrollBottom: function(){
		$('html, body').animate({scrollTop:$(document).height()}, 500);
	},
	scrollTop: function(){
		window.scrollTo(0, 0);
	},
	number_format: function(number, decimals, dec_point, thousands_sep) {


	 number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
	  var n = !isFinite(+number) ? 0 : +number,
	    prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
	    sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
	    dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
	    s = '',
	    toFixedFix = function(n, prec) {
	      var k = Math.pow(10, prec);
	      return '' + (Math.round(n * k) / k)
	        .toFixed(prec);
	    };
	  // Fix for IE parseFloat(0.55).toFixed(0) = 0;
	  s = (prec ? toFixedFix(n, prec) : '' + Math.round(n))
	    .split('.');
	  if (s[0].length > 3) {
	    s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
	  }
	  if ((s[1] || '')
	    .length < prec) {
	    s[1] = s[1] || '';
	    s[1] += new Array(prec - s[1].length + 1)
	      .join('0');
	  }
	  return s.join(dec);
	}

};


/**
* Function : dump()
* Arguments: The data - array,hash(associative array),object
*    The level - OPTIONAL
* Returns  : The textual representation of the array.
* This function was inspired by the print_r function of PHP.
* This will accept some data as the argument and return a
* text that will be a more readable version of the
* array/hash/object that is given.
*/
function dump(arr,level) {
var dumped_text = "";
if(!level) level = 0;

//The padding given at the beginning of the line.
var level_padding = "";
for(var j=0;j<level+1;j++) level_padding += "    ";

if(typeof(arr) == 'object') { //Array/Hashes/Objects
 for(var item in arr) {
  var value = arr[item];
 
  if(typeof(value) == 'object') { //If it is an array,
   dumped_text += level_padding + "'" + item + "' ...\n";
   dumped_text += dump(value,level+1);
  } else {
   dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
  }
 }
} else { //Stings/Chars/Numbers etc.
 dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
}
return dumped_text;
} 